com.ihr.xbrl.dts

## Class PMember

- java.lang.Object
- - com.ihr.xbrl.dts.PMember

- All Implemented Interfaces:
    Member<MemberInfo>, java.io.Serializable, java.lang.Cloneable

      public class PMember
      extends java.lang.Object
      implements Member<MemberInfo>

  This class holds a domain of members.
  Author:
    Ignacio
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PMember(XBRLTreeNode node, DDimension dim)` Instantiates a new p member.
    `PMember(XBRLTreeNode node, DDimension dim, boolean bRemoveXDTElements, XMLElementDefinition hc, XMLElementDefinition di)` Instantiates a new p member.
    `PMember(XDTDomainMemberUse dmu, XDimension dim)` Instantiates a new p member.
    `PMember(XMLElementDefinition item, Dimension<?> dim)` Instantiates a new p member.
    `PMember(XMLElementDefinition item, XBRLRelationship rel, Dimension<?> dim)` Instantiates a new p member.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDomain(java.util.Collection<Member<?>> members)` Adds a domain of members.
    `void` | `buildDomain(XBRLRelationship rel)` Builds the domain.
    `Member<MemberInfo>` | `clone()` Clone constructor.
    `void` | `collectDimensions(java.util.HashSet<ClsPackQNameContainer> hsDimensions, com.ihr.xbrl.dts.DimensionalInstanceExplorerCommonParametersContext dContext)` Explore concept definition for additional dimensions and add them to the Dimensions HashSet.
    `int` | `compareTo(Member<?> o2)` Compare to.
    `boolean` | `equals(java.lang.Object obj)`
    `Dimension<?>` | `getDimension()` Access back to the dimensions this member has belongs to.
    `java.util.Collection<Member<?>>` | `getDomain()` Returns the available sub members of this member.
    `HandleDateStep.InstantMode` | `getInstantMode()` Gets the instant mode.
    `MemberInfo` | `getMember()` Access to the member.
    `boolean` | `hasDomain()` Returns true if the member is a Domain and has sub-members.
    `int` | `hashCode()`
    `boolean` | `isAbstract()` This method returns true if the member associated is abstract.
    `boolean` | `isDefault()` Checks if is default.
    `boolean` | `isNegated()` Negated are shown in red color font.
    `boolean` | `isNet()` Nets are shown in bold font.
    `boolean` | `isPrimary()` This method returns true if the member is a primary item, otherwise is a dimension member of either an XDT dimension or a Virtual dimension.
    `boolean` | `isTotal()` Totals are shown in bold font.
    `boolean` | `isVisible()` Must return true if the member is going to be visualized in rows or columns.
    `Dimension<?>` | `setDimension(Dimension<?> newDimension)` Set or change the assigned dimension of this member
    `void` | `setHidden()` Sets the hidden.
    `void` | `setVisible()` Sets the visible.
    `void` | `setVisible(boolean value)` Sets the visibility parameter value for this member.
    `XMLFragment` | `toFragment(DTSContainer dts)` To fragment.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PMember

          public PMember(XMLElementDefinition item,
                 Dimension<?> dim)

      Instantiates a new p member.
      Parameters:
        `item` - the item
        `dim` - the dim

    - #### PMember

          public PMember(XMLElementDefinition item,
                 XBRLRelationship rel,
                 Dimension<?> dim)

      Instantiates a new p member.
      Parameters:
        `item` - the item
        `rel` - the rel
        `dim` - the dim

    - #### PMember

          public PMember(XDTDomainMemberUse dmu,
                 XDimension dim)

      Instantiates a new p member.
      Parameters:
        `dmu` - the dmu
        `dim` - the dim

    - #### PMember

          public PMember(XBRLTreeNode node,
                 DDimension dim)

      Instantiates a new p member.
      Parameters:
        `node` - the node
        `dim` - the dim

    - #### PMember

          public PMember(XBRLTreeNode node,
                 DDimension dim,
                 boolean bRemoveXDTElements,
                 XMLElementDefinition hc,
                 XMLElementDefinition di)

      Instantiates a new p member.
      Parameters:
        `node` - the node
        `dim` - the dim
        `bRemoveXDTElements` - the b remove xdt elements
        `hc` - the hc
        `di` - the di

  - ### Method Detail

    - #### clone

          public Member<MemberInfo> clone()

      Description copied from interface: `Member`
      Clone constructor.
      Specified by:
        `clone` in interface `Member<MemberInfo>`
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        the member

    - #### buildDomain

          public void buildDomain(XBRLRelationship rel)

      Builds the domain.
      Parameters:
        `rel` - the rel

    - #### getMember

          public MemberInfo getMember()

      Description copied from interface: `Member`
      Access to the member.
      Specified by:
        `getMember` in interface `Member<MemberInfo>`
      Returns:
        element of the class of the Member type

    - #### getDomain

          public java.util.Collection<Member<?>> getDomain()

      Description copied from interface: `Member`
      Returns the available sub members of this member. In the case there were no sub-members the function returns null.
      Specified by:
        `getDomain` in interface `Member<MemberInfo>`
      Returns:
        Collection of sub members of class T
      See Also:
        `Member.hasDomain()`

    - #### hasDomain

          public boolean hasDomain()

      Description copied from interface: `Member`
      Returns true if the member is a Domain and has sub-members.
      Specified by:
        `hasDomain` in interface `Member<MemberInfo>`
      Returns:
        boolean value

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### isTotal

          public boolean isTotal()

      Description copied from interface: `Member`
      Totals are shown in bold font. This method returns true when the item is assigned to a total role
      Specified by:
        `isTotal` in interface `Member<MemberInfo>`
      Returns:
        true, if is total

    - #### isNet

          public boolean isNet()

      Description copied from interface: `Member`
      Nets are shown in bold font. This method returns true when the item is assigned the net role
      Specified by:
        `isNet` in interface `Member<MemberInfo>`
      Returns:
        true, if is net

    - #### isNegated

          public boolean isNegated()

      Description copied from interface: `Member`
      Negated are shown in red color font. This method returns true when the item is assigned to a negated role
      Specified by:
        `isNegated` in interface `Member<MemberInfo>`
      Returns:
        true, if is negated

    - #### addDomain

          public void addDomain(java.util.Collection<Member<?>> members)

      Description copied from interface: `Member`
      Adds a domain of members. This method should be called only if the member has no domain. This method should use the clone<T> method for adding copies of the members that are passed as parameter
      Specified by:
        `addDomain` in interface `Member<MemberInfo>`
      Parameters:
        `members` - the members

    - #### isAbstract

          public boolean isAbstract()

      Description copied from interface: `Member`
      This method returns true if the member associated is abstract.
      Specified by:
        `isAbstract` in interface `Member<MemberInfo>`
      Returns:
        boolean

    - #### isPrimary

          public boolean isPrimary()

      Description copied from interface: `Member`
      This method returns true if the member is a primary item, otherwise is a dimension member of either an XDT dimension or a Virtual dimension.
      Specified by:
        `isPrimary` in interface `Member<MemberInfo>`
      Returns:
        true, if is primary

    - #### isVisible

          public boolean isVisible()

      Description copied from interface: `Member`
      Must return true if the member is going to be visualized in rows or columns. If false, the member will be hidden and all children elements too
      Specified by:
        `isVisible` in interface `Member<MemberInfo>`
      Returns:
        boolean value

    - #### setVisible

          public void setVisible()

      Sets the visible.

    - #### setVisible

          public void setVisible(boolean value)

      Description copied from interface: `Member`
      Sets the visibility parameter value for this member.
      Specified by:
        `setVisible` in interface `Member<MemberInfo>`
      Parameters:
        `value` - the new visible

    - #### setHidden

          public void setHidden()

      Sets the hidden.

    - #### getDimension

          public Dimension<?> getDimension()

      Description copied from interface: `Member`
      Access back to the dimensions this member has belongs to.
      Specified by:
        `getDimension` in interface `Member<MemberInfo>`
      Returns:
        the dimension

    - #### setDimension

          public Dimension<?> setDimension(Dimension<?> newDimension)

      Description copied from interface: `Member`
      Set or change the assigned dimension of this member
      Specified by:
        `setDimension` in interface `Member<MemberInfo>`
      Parameters:
        `newDimension` - the new dimension
      Returns:
        the previouly assigned dimension or null

    - #### isDefault

          public boolean isDefault()

      Checks if is default.
      Returns:
        true, if is default

    - #### toFragment

          public XMLFragment toFragment(DTSContainer dts)

      To fragment.
      Parameters:
        `dts` - the dts
      Returns:
        the XML fragment

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### compareTo

          public int compareTo(Member<?> o2)

      Description copied from interface: `Member`
      Compare to.
      Specified by:
        `compareTo` in interface `Member<MemberInfo>`
      Parameters:
        `o2` - the o2
      Returns:
        the int

    - #### collectDimensions

          public void collectDimensions(java.util.HashSet<ClsPackQNameContainer> hsDimensions,
                               com.ihr.xbrl.dts.DimensionalInstanceExplorerCommonParametersContext dContext)

      Explore concept definition for additional dimensions and add them to the Dimensions HashSet.
      Parameters:
        `hsDimensions` - the hs dimensions
        `dContext` - the d context

    - #### getInstantMode

          public HandleDateStep.InstantMode getInstantMode()

      Gets the instant mode.
      Returns:
        the instant mode